## fcam 1.0.0-2

=== Makefile ===
### FCam library Makefile

## Define project directories
SOURCE_DIR=src
INCLUDE_DIR=include
RELEASE_DIR=release
DEBUG_DIR=debug
BINARY_DIR=bin
LAST_MAKE_TRACKER=.last_make

## Define all general FCam source files
SOURCES =  Action.cpp AutoExposure.cpp AutoFocus.cpp AutoWhiteBalance.cpp AsyncFile.cpp 
SOURCES += Base.cpp Device.cpp Event.cpp Flash.cpp Frame.cpp Image.cpp 
SOURCES += Lens.cpp Shot.cpp Sensor.cpp Time.cpp TagValue.cpp 
SOURCES += processing/DNG.cpp processing/TIFF.cpp processing/TIFFTags.cpp
SOURCES += processing/Dump.cpp processing/JPEG.cpp processing/Demosaic.cpp processing/Color.cpp
SOURCES += Dummy/Sensor.cpp Dummy/Frame.cpp Dummy/Shot.cpp Dummy/Daemon.cpp Dummy/Platform.cpp

## Overall build options
CXXFLAGS += -Wall -I$(INCLUDE_DIR)
CXXFLAGS_RELEASE = -O3
CXXFLAGS_DEBUG = -g -O0 -D DEBUG -D FCAM_DEBUG_LEVEL=$(DEBUG_LEVEL)
CXXFLAGS_ARM = -march=armv7-a -mtune=cortex-a8 -mfpu=neon -mfloat-abi=softfp
CXXFLAGS_X86 = -msse3 -mfpmath=sse
DEBUG_LEVEL=0

## Let's ask compiler about its target processor
MACH := $(shell $(CXX) -dumpmachine)

## Determine target platform - fairly brittle right now
ifdef OE_QMAKE_CXX
 PLATFORM=f2
 PLATFORM_UC=F2
 ARCH=ARM
else
 ifneq (,$(findstring arm, $(MACH)))
  PLATFORM=n900
  PLATFORM_UC=N900
  ARCH=ARM
 else
  ifneq (,$(findstring apple, $(MACH)))
   PLATFORM=osx
   PLATFORM_UC=OSX
   ARCH=X86
  else
   PLATFORM=x86
   PLATFORM_UC=X86
   ARCH=X86
  endif
 endif
endif

CXXFLAGS += -D FCAM_PLATFORM_$(PLATFORM_UC) -D FCAM_ARCH_$(ARCH)

## Set up object file names

DEBUG_OBJECTS=$(SOURCES:%.cpp=$(DEBUG_DIR).$(PLATFORM)/%.o)
RELEASE_OBJECTS=$(SOURCES:%.cpp=$(RELEASE_DIR).$(PLATFORM)/%.o)

## Set up platform-specific details

ifeq ($(PLATFORM),f2)
 $(info ** Compiling FCam for F2/Angstrom **)
 # The below redirect a bunch of stuff to /usr/local/angstrom-land
 CXX = $(OE_QMAKE_CXX)
 AR = $(OE_QMAKE_AR)
 CXXFLAGS += $(CXXFLAGS_ARM) $(INCPATH)
 LIBS = -lrt
 SOURCES += F2/Platform.cpp F2/Sensor.cpp F2/Shot.cpp F2/Frame.cpp
 SOURCES += F2/Lens.cpp F2/Flash.cpp 
 SOURCES += F2/EF232LensDatabase.cpp F2/PhidgetDevice.cpp F2/ShutterButton.cpp 
 SOURCES += F2/Daemon.cpp F2/V4L2Sensor.cpp  
 SOURCES += processing/Demosaic_ARM.cpp
endif

ifeq ($(PLATFORM),n900)
 $(info ** Compiling FCam for N900/Maemo **)
 # This is all inside madde/scratchbox, so no odd prefixes are required
 CXX = g++
 AR = ar
 CXXFLAGS += $(CXXFLAGS_ARM)
 LIBS = -lrt
 SOURCES += N900/ButtonListener.cpp N900/Sensor.cpp N900/Daemon.cpp N900/V4L2Sensor.cpp 
 SOURCES += N900/Lens.cpp N900/Flash.cpp N900/Platform.cpp N900/Frame.cpp 
 SOURCES += processing/Demosaic_ARM.cpp
endif

ifeq ($(PLATFORM),osx)
 $(info ** Compiling FCam for OS X/macports **)
 # Assumes macports libraries (libjpeg, etc) exist
 CXX = g++
 AR = ar
 CXXFLAGS += -I /opt/local/include $(CXXFLAGS_X86)
 LIBS = -L/opt/local/lib
endif

ifeq ($(PLATFORM),x86)
 $(info ** Compiling FCam for x86/Posix **)
 # Basic X86 compile
 CXX = g++
 AR = ar
 CXXFLAGS += $(CXXFLAGS_X86)
 LIBS =	-lrt
endif

## Main build targets

all: release 

# Optimized build
.PHONY: release
release: CXXFLAGS += $(CXXFLAGS_RELEASE)
release: BUILD_DIR=$(RELEASE_DIR).$(PLATFORM)
release: OBJECTS=$(RELEASE_OBJECTS)
release: make_dirs $(RELEASE_DIR).$(PLATFORM)/libFCam.a
	@echo '** Release mode **'

# Debug build
.PHONY: debug
debug: CXXFLAGS += $(CXXFLAGS_DEBUG)
debug: BUILD_DIR=$(DEBUG_DIR).$(PLATFORM)
debug: OBJECTS=$(DEBUG_OBJECTS)
debug: make_dirs $(DEBUG_DIR).$(PLATFORM)/libFCam.a
	@echo '** Debug mode **'

# Documentation and distribution
.PHONY: docs
docs:
	doxygen

.PHONY: package
package: release
	-rm FCam.zip
	svn -R list | zip -@ FCam.zip
	find libFCam.a examples/bin/example? doc | zip -@ FCam.zip

.PHONY: srcpackage
srcpackage:
	-rm FCam.zip
	svn -R list | zip -@ FCam.zip

.PHONY: install
install: release
	mkdir -p $(DESTDIR)/usr/include/FCam/{N900,F2,Dummy,processing} $(DESTDIR)/usr/lib
	find include/FCam -name '*.h' -exec cp '{}' '$(DESTDIR)/usr/{}' ';'
	cp libFCam.a $(DESTDIR)/usr/lib

deb:
	dpkg-buildpackage -rfakeroot -b -uc

deb-src:
	dpkg-buildpackage -rfakeroot -sa -S

# Clean it all up
.PHONY: clean
clean: 
	-rm -f libFCam.a 
	-rm -rf $(RELEASE_DIR).*
	-rm -rf $(DEBUG_DIR).*
	-rm -rf $(BINARY_DIR)
	-rm -f $(LAST_MAKE_TRACKER)

## Subsidiary targets

# Create needed directories
.PHONY: make_dirs
make_dirs:
	@-mkdir -p $(BUILD_DIR)/{processing,F2,N900,Dummy} $(BINARY_DIR)

# Release library build
$(RELEASE_DIR).$(PLATFORM)/libFCam.a: $(RELEASE_OBJECTS) $(LAST_MAKE_TRACKER) | make_dirs 
	@echo $(BUILD_DIR) > $(LAST_MAKE_TRACKER)
	@rm -f $@
	$(AR) cq $@ $(OBJECTS)
	@cp $@ .

# Debug library build
$(DEBUG_DIR).$(PLATFORM)/libFCam.a: $(DEBUG_OBJECTS) $(LAST_MAKE_TRACKER) | make_dirs 
	@echo $(BUILD_DIR) > $(LAST_MAKE_TRACKER)
	@rm -f $@
	$(AR) cq $@ $(OBJECTS) 
	@cp $@ .

# To deal with initial run when $(LAST_MAKE_TRACKER) doesn't exist
$(LAST_MAKE_TRACKER):

# Real build rule, with dependency generation by GCC
$(DEBUG_DIR).$(PLATFORM)/%.o $(RELEASE_DIR).$(PLATFORM)/%.o: $(SOURCE_DIR)/%.cpp
	$(CXX) $(CXXFLAGS) -MMD -MP -MF $(BUILD_DIR)/$*.d -MT $(BUILD_DIR)/$*.o -c $< -o $@	

# Generated dependency inclusion
-include $(RELEASE_OBJECTS:.o=.d)
-include $(DEBUG_OBJECTS:.o=.d)

### Unit test programs 

## Base FCam tests
TESTS = testImage testDemosaic testDNG testTSQueue testTagValue testFlashLatency
## F2-specific tests
ifeq ($(PLATFORM),F2)
TESTS += testF2 testF2Lens
endif

## Test code libraries
CXXTESTFLAGS= $(CXXFLAGS)
TESTLIBS = $(LIBS) -lpthread -ltiff -ljpeg #-L. -lFCam 

## Test code build targets
tests: $(TESTS)

## Base FCam test targets, works for anything named tests/test*.cpp. For a release version test build, append -r to target name.

test%: tests/test%.cpp debug
	$(CXX) -O3 $(CXXTESTFLAGS) $(CXXFLAGS_DEBUG) -o $(DEBUG_DIR).$(PLATFORM)/test$* $< $(DEBUG_OBJECTS) $(TESTLIBS)
	cp $(DEBUG_DIR).$(PLATFORM)/test$* $(BINARY_DIR)

test%-r: tests/test%.cpp release
	$(CXX) -O3 $(CXXTESTFLAGS) -g $(CXXFLAGS_RELEASE) -o $(RELEASE_DIR).$(PLATFORM)/test$* $< $(RELEASE_OBJECTS) $(TESTLIBS)
	cp $(RELEASE_DIR).$(PLATFORM)/test$* $(BINARY_DIR)

## fcam 1.0.0-1

=== debian/changelog ===
fcam (1.0.0-1) unstable; urgency=low

  * Initial release

 -- Eino-Ville Talvala <talvala@stanford.edu>  Tue, 20 Jul 2010 15:59:38 -0700

=== debian/control ===
Source: fcam
Priority: extra
Maintainer: Eino-Ville Talvala <talvala@stanford.edu>
Build-Depends: debhelper (>= 5), libjpeg-dev
Standards-Version: 3.7.2
Section: libs

Package: fcam-dev
Section: libdevel
Architecture: any
Depends: libjpeg
Description: FCam Camera Control API
XSBC-Bugtracker: https://garage.maemo.org/tracker/?group_id=1693
 Development package for the FCam camera control API.
 Enables full, precise control of the the N900 camera subsystem,
 including sensor, lens, and flash.

## fcam 1.0.0-2

=== debian/changelog ===
fcam (1.0.0-2) unstable; urgency=low

  * Fixed packaging dependencies on libjpeg.

 -- Eino-Ville Talvala <talvala@stanford.edu>  Tue, 20 Jul 2010 18:49:38 -0700

## fcam 1.0.0-3

=== Makefile ===
--- 
+++ 
@@ -145,11 +145,12 @@
 	find include/FCam -name '*.h' -exec cp '{}' '$(DESTDIR)/usr/{}' ';'
 	cp libFCam.a $(DESTDIR)/usr/lib
 
+# Build release packages for distribution
 deb:
 	dpkg-buildpackage -rfakeroot -b -uc
 
 deb-src:
-	dpkg-buildpackage -rfakeroot -sa -S
+	dpkg-buildpackage -rfakeroot -sa -S -I'\.svn'
 
 # Clean it all up
 .PHONY: clean

=== examples/example4/Makefile ===

TARGET  := ../bin/example4

CC      := g++
CFLAGS  := -g -Wall -I../../include
LDFLAGS := -L../.. -lFCam -ljpeg -lpthread
FILES   := example4

OBJS = $(addsuffix .o, $(FILES))

.cpp.o:
	$(CC) $(CFLAGS) -c $< -o $@

build: $(OBJS)
	$(CC) -o $(TARGET) $(OBJS) $(LDFLAGS)

clean:
	rm -rf *.o $(TARGET) .\#* \#* *~ core

=== debian/changelog ===
fcam (1.0.0-3) unstable; urgency=low

  * Removed accidental .svn inclusion in package

 -- Eino-Ville Talvala <talvala@stanford.edu>  Tue, 20 Jul 2010 18:49:38 -0700

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 Package: fcam-dev
 Section: libdevel
 Architecture: any
-Depends: libjpeg
+Depends: libjpeg-dev
 Description: FCam Camera Control API
 XSBC-Bugtracker: https://garage.maemo.org/tracker/?group_id=1693
  Development package for the FCam camera control API.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1






# shared library versions, option 1
version=2.0.5
major=2
# option 2, assuming the library is created as src/.libs/libfoo.so.2.0.5 or so
#version=`ls src/.libs/lib*.so.* | \
# awk '{if (match($$0,/[0-9]+\.[0-9]+\.[0-9]+$$/)) print substr($$0,RSTART)}'`
#major=`ls src/.libs/lib*.so.* | \
# awk '{if (match($$0,/\.so\.[0-9]+$$/)) print substr($$0,RSTART+4)}'`

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp


build: build-stamp
build-stamp: configure-stamp  
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)

	touch $@

clean: 
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	$(MAKE) clean

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/tmp
	$(MAKE) DESTDIR="$(CURDIR)"/debian/fcam-dev install


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_python
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## fcam 1.0.0-4

=== Makefile ===
--- 
+++ 
@@ -131,6 +131,8 @@
 .PHONY: package
 package: release
 	-rm FCam.zip
+	make -C examples
+	doxygen
 	svn -R list | zip -@ FCam.zip
 	find libFCam.a examples/bin/example? doc | zip -@ FCam.zip

=== examples/example1/Makefile ===

ifdef OE_QMAKE_CXX

$(info ** Compiling for Angstrom **)
CC = $(OE_QMAKE_CXX)
AR = $(OE_QMAKE_AR)
CXXFLAGS += $(INCPATH)
PLATFORM=PLATFORM_F2
else

$(info ** Compiling for Maemo **)
CC      := g++
PLATFORM=PLATFORM_N900
endif

TARGET  := ../bin/example1

CC      := g++
CFLAGS  := -g -Wall -I../../include
LDFLAGS := -L ../.. -lFCam -ljpeg -lpthread 
FILES   := example1

OBJS = $(addsuffix .o, $(FILES))

.cpp.o:
	$(CC) $(CFLAGS) -c $< -o $@

build: $(OBJS)
	$(CC) -o $(TARGET) $(OBJS) $(LDFLAGS)

clean:
	rm -rf *.o $(TARGET) .\#* \#* *~ core

=== examples/example2/Makefile ===

TARGET  := ../bin/example2

CC      := g++
CFLAGS  := -g -Wall -I../../include
LDFLAGS := -L ../.. -lFCam -ljpeg -lpthread
FILES   := example2

OBJS = $(addsuffix .o, $(FILES))

.cpp.o:
	$(CC) $(CFLAGS) -c $< -o $@

build: $(OBJS)
	$(CC) -o $(TARGET) $(OBJS) $(LDFLAGS)

clean:
	rm -rf *.o $(TARGET) .\#* \#* *~ core

=== debian/changelog ===
fcam (1.0.0-4) unstable; urgency=low

  * Removed Depends: libjpeg-dev until it gets sorted out properly.

 -- Eino-Ville Talvala <talvala@stanford.edu>  Tue, 20 Jul 2010 21:04:28 -0700

=== debian/control ===
Source: fcam
Priority: extra
Maintainer: Eino-Ville Talvala <talvala@stanford.edu>
Build-Depends: debhelper (>= 5), libjpeg-dev
Standards-Version: 3.7.2
Section: libs
Homepage: http://fcam.garage.maemo.org/

Package: fcam-dev
Section: libdevel
Architecture: any
Depends: 
Description: FCam Camera Control API
XSBC-Bugtracker: https://garage.maemo.org/tracker/?group_id=1693
 Development package for the FCam camera control API.
 Enables full, precise control of the the N900 camera subsystem,
 including the sensor, lens, and flash.

## fcam 1.0.1-1

=== debian/changelog ===
fcam (1.0.1-1) unstable; urgency=low

  * Fixed cyan-tinted DNG due to malformed DNG metadata.

  * Added homepage link.

 -- Eino-Ville Talvala <talvala@stanford.edu>  Tue, 20 Jul 2010 21:04:28 -0700

=== debian/control ===
Source: fcam
Priority: extra
Maintainer: Eino-Ville Talvala <talvala@stanford.edu>
Build-Depends: debhelper (>= 5), libjpeg62-dev
Standards-Version: 3.7.2
Section: libs
Homepage: http://fcam.garage.maemo.org/

Package: fcam-dev
Section: libdevel
Architecture: any
Depends: libjpeg62-dev 
Description: FCam Camera Control API
XSBC-Bugtracker: https://garage.maemo.org/tracker/?group_id=1693
 Development package for the FCam camera control API.
 Enables full, precise control of the the N900 camera subsystem,
 including the sensor, lens, and flash.

## fcam 1.1.0-1

=== examples/example7/Makefile ===
#############################################################################
# Makefile for building: example7
# Generated by qmake (2.01a) (Qt 4.6.2) on: Thu Jul 22 17:50:30 2010
# Project:  example7.pro
# Template: app
# Command: c:/NokiaQtSDK/Maemo/4.6.2/targets/fremantle-pr12/bin/qmake.exe -unix -o Makefile example7.pro
#############################################################################

first: debug
install: debug-install
uninstall: debug-uninstall
MAKEFILE      = Makefile
QMAKE         = c:/NokiaQtSDK/Maemo/4.6.2/targets/fremantle-pr12/bin/qmake.exe
DEL_FILE      = rm
CHK_DIR_EXISTS= test -d
MKDIR         = mkdir
COPY          = cp
COPY_FILE     = $(COPY)
COPY_DIR      = xcopy /s /q /y /i
INSTALL_FILE  = $(COPY_FILE)
INSTALL_PROGRAM = $(COPY_FILE)
INSTALL_DIR   = $(COPY_DIR)
DEL_FILE      = rm
SYMLINK       = 
DEL_DIR       = rmdir
MOVE          = mv
CHK_DIR_EXISTS= test -d
MKDIR         = mkdir
SUBTARGETS    =  \
		debug \
		release

debug: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug
debug-make_default: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug 
debug-make_first: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug first
debug-all: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug all
debug-clean: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug clean
debug-distclean: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug distclean
debug-install: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug install
debug-uninstall: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug uninstall
release: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release
release-make_default: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release 
release-make_first: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release first
release-all: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release all
release-clean: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release clean
release-distclean: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release distclean
release-install: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release install
release-uninstall: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release uninstall

Makefile: example7.pro  c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/win32-g++/qmake.conf c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/qconfig.pri \
		c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/qt_functions.prf \
		c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/qt_config.prf \
		c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/exclusive_builds.prf \
		c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/default_pre.prf \
		c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/debug.prf \
		c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/debug_and_release.prf \
		c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/default_post.prf \
		c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/qt.prf \
		c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/unix/thread.prf \
		c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/moc.prf \
		c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/warn_on.prf \
		c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/resources.prf \
		c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/uic.prf \
		c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/yacc.prf \
		c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/lex.prf \
		c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/include_source_dir.prf
	$(QMAKE) -unix -o Makefile example7.pro
c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/qconfig.pri:
c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/qt_functions.prf:
c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/qt_config.prf:
c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/exclusive_builds.prf:
c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/default_pre.prf:
c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/debug.prf:
c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/debug_and_release.prf:
c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/default_post.prf:
c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/qt.prf:
c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/unix/thread.prf:
c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/moc.prf:
c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/warn_on.prf:
c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/resources.prf:
c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/uic.prf:
c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/yacc.prf:
c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/lex.prf:
c:/NokiaQtSDK/Maemo/4.6.2/sysroots/fremantle-arm-sysroot-10.2010.19-1-slim/usr/share/qt4/mkspecs/features/include_source_dir.prf:
qmake: qmake_all FORCE
	@$(QMAKE) -unix -o Makefile example7.pro

qmake_all: FORCE

make_default: debug-make_default release-make_default FORCE
make_first: debug-make_first release-make_first FORCE
all: debug-all release-all FORCE
clean: debug-clean release-clean FORCE
distclean: debug-distclean release-distclean FORCE
	-$(DEL_FILE) Makefile

debug-mocclean: $(MAKEFILE).Debug
	$(MAKE) -f $(MAKEFILE).Debug mocclean
release-mocclean: $(MAKEFILE).Release
	$(MAKE) -f $(MAKEFILE).Release mocclean
mocclean: debug-mocclean release-mocclean

debug-mocables: $(MAKEFILE).Debug
	$(MAKE) -f $(MAKEFILE).Debug mocables
release-mocables: $(MAKEFILE).Release
	$(MAKE) -f $(MAKEFILE).Release mocables
mocables: debug-mocables release-mocables
FORCE:

$(MAKEFILE).Debug: Makefile
$(MAKEFILE).Release: Makefile

=== changelog ===
fcam (1.0.1-2) unstable; urgency=low

  * Removed libjpeg62-dev as a dependency, causes warning in package system.

 -- Eino-Ville Talvala <talvala@stanford.edu>  Tue, 20 Jul 2010 21:04:28 -0700

=== debian/changelog ===
fcam (1.1.0-1) unstable; urgency=low

  * Numerous DNG updates and fixes: Now works with dcraw, color rendition improved in general, ACR 2010 denoising works.

  * Compatibility with N900 built-in camera night mode and BlessN900.

  * Added memory-mapped Image support

  * API break: Improved WB handling: Shots can now contain a custom WB matrix instead of just a color temperature.

  * Correct date->month conversion.

  * Various error checking improvements throughout the codebase.

 -- Eino-Ville Talvala <talvala@stanford.edu>  Mon, 16 Aug 2010 13:30:00 -0700

## fcam 1.1.0-2

=== debian/changelog ===
fcam (1.1.0-2) unstable; urgency=low

  * Removed unneeded files from package

 -- Eino-Ville Talvala <talvala@stanford.edu>  Mon, 16 Aug 2010 15:20:00 -0700

## fcam 1.1.1-1

=== Makefile ===
--- 
+++ 
@@ -29,25 +29,25 @@
 
 ## Determine target platform - fairly brittle right now
 ifdef OE_QMAKE_CXX
- PLATFORM=f2
- PLATFORM_UC=F2
- ARCH=ARM
-else
- ifneq (,$(findstring arm, $(MACH)))
+  PLATFORM=f2
+  PLATFORM_UC=F2
+  ARCH=ARM
+else ifneq (,$(findstring arm, $(MACH)))
   PLATFORM=n900
   PLATFORM_UC=N900
   ARCH=ARM
- else
-  ifneq (,$(findstring apple, $(MACH)))
-   PLATFORM=osx
-   PLATFORM_UC=OSX
-   ARCH=X86
-  else
-   PLATFORM=x86
-   PLATFORM_UC=X86
-   ARCH=X86
-  endif
- endif
+else ifneq (,$(findstring apple, $(MACH)))
+  PLATFORM=osx
+  PLATFORM_UC=OSX
+  ARCH=X86
+else ifneq (,$(findstring cygwin, $(MACH)))
+  PLATFORM=cygwin
+  PLATFORM_UC=CYGWIN
+  ARCH=X86
+else 
+  PLATFORM=x86
+  PLATFORM_UC=X86
+  ARCH=X86
 endif
 
 CXXFLAGS += -D FCAM_PLATFORM_$(PLATFORM_UC) -D FCAM_ARCH_$(ARCH)
@@ -94,6 +94,15 @@
  LIBS = -L/opt/local/lib
 endif
 
+ifeq ($(PLATFORM),cygwin)
+ $(info ** Compiling FCam for x86/Cygwin **)
+ # Basic X86 compile
+ CXX = g++
+ AR = ar
+ CXXFLAGS += $(CXXFLAGS_X86)
+ LIBS =	-lrt
+endif
+
 ifeq ($(PLATFORM),x86)
  $(info ** Compiling FCam for x86/Posix **)
  # Basic X86 compile
@@ -143,7 +152,11 @@
 
 .PHONY: install
 install: release
-	mkdir -p $(DESTDIR)/usr/include/FCam/{N900,F2,Dummy,processing} $(DESTDIR)/usr/lib
+	mkdir -p $(DESTDIR)/usr/lib
+	mkdir -p $(DESTDIR)/usr/include/FCam/N900
+	mkdir -p $(DESTDIR)/usr/include/FCam/F2
+	mkdir -p $(DESTDIR)/usr/include/FCam/Dummy
+	mkdir -p $(DESTDIR)/usr/include/FCam/processing
 	find include/FCam -name '*.h' -exec cp '{}' '$(DESTDIR)/usr/{}' ';'
 	cp libFCam.a $(DESTDIR)/usr/lib
 
@@ -168,7 +181,11 @@
 # Create needed directories
 .PHONY: make_dirs
 make_dirs:
-	@-mkdir -p $(BUILD_DIR)/{processing,F2,N900,Dummy} $(BINARY_DIR)
+	@-mkdir -p $(BUILD_DIR)/processing
+	@-mkdir -p $(BUILD_DIR)/F2
+	@-mkdir -p $(BUILD_DIR)/N900
+	@-mkdir -p $(BUILD_DIR)/Dummy
+	@-mkdir -p $(BINARY_DIR)
 
 # Release library build
 $(RELEASE_DIR).$(PLATFORM)/libFCam.a: $(RELEASE_OBJECTS) $(LAST_MAKE_TRACKER) | make_dirs 
@@ -206,7 +223,7 @@
 
 ## Test code libraries
 CXXTESTFLAGS= $(CXXFLAGS)
-TESTLIBS = $(LIBS) -lpthread -ltiff -ljpeg #-L. -lFCam 
+TESTLIBS = $(LIBS) -L. -lFCam -lpthread -ljpeg 
 
 ## Test code build targets
 tests: $(TESTS)
@@ -214,10 +231,18 @@
 ## Base FCam test targets, works for anything named tests/test*.cpp. For a release version test build, append -r to target name.
 
 test%: tests/test%.cpp debug
-	$(CXX) -O3 $(CXXTESTFLAGS) $(CXXFLAGS_DEBUG) -o $(DEBUG_DIR).$(PLATFORM)/test$* $< $(DEBUG_OBJECTS) $(TESTLIBS)
+	$(CXX) -O3 $(CXXTESTFLAGS) $(CXXFLAGS_DEBUG) -o $(DEBUG_DIR).$(PLATFORM)/test$* $< $(TESTLIBS)
 	cp $(DEBUG_DIR).$(PLATFORM)/test$* $(BINARY_DIR)
 
 test%-r: tests/test%.cpp release
-	$(CXX) -O3 $(CXXTESTFLAGS) -g $(CXXFLAGS_RELEASE) -o $(RELEASE_DIR).$(PLATFORM)/test$* $< $(RELEASE_OBJECTS) $(TESTLIBS)
+	$(CXX) -O3 $(CXXTESTFLAGS) -g $(CXXFLAGS_RELEASE) -o $(RELEASE_DIR).$(PLATFORM)/test$* $< $(TESTLIBS)
 	cp $(RELEASE_DIR).$(PLATFORM)/test$* $(BINARY_DIR)
 
+### Utility programs 
+UTILS = fcamDngUtil
+
+utils: $(UTILS)
+
+fcamDngUtil: utils/fcamDngUtil.cpp release
+	$(CXX) -O3 $(CXXFLAGS) -o $(RELEASE_DIR).${PLATFORM}/$@ $<  $(TESTLIBS) 
+	cp $(RELEASE_DIR).${PLATFORM}/$@ $(BINARY_DIR)

=== examples/Makefile ===

all:
	mkdir -p bin
	make -C example1
	make -C example2
	make -C example3	
	make -C example4
	make -C example5
	make -C example6
	cd example7 && qmake
	make -C example7

clean:
	make -C example1 clean
	make -C example2 clean
	make -C example3 clean
	make -C example4 clean
	make -C example5 clean
	make -C example6 clean
	make -C example7 distclean
	rm -rf *~ \#* .\#*

=== examples/example3/Makefile ===

TARGET  := ../bin/example3

CC      := g++
CFLAGS  := -g -Wall -I../../include
LDFLAGS := -L ../.. -lFCam -ljpeg -lpthread
FILES   := example3

OBJS = $(addsuffix .o, $(FILES))

.cpp.o:
	$(CC) $(CFLAGS) -c $< -o $@

build: $(OBJS)
	$(CC) -o $(TARGET) $(OBJS) $(LDFLAGS)

clean:
	rm -rf *.o $(TARGET) .\#* \#* *~ core

=== examples/example5/Makefile ===

TARGET  := ../bin/example5

CC      := g++
CFLAGS  := -g -Wall -I../../include
LDFLAGS := -L../.. -lFCam -ljpeg -lpthread
FILES   := example5

OBJS = $(addsuffix .o, $(FILES))

.cpp.o:
	$(CC) $(CFLAGS) -c $< -o $@

build: $(OBJS)
	$(CC) -o $(TARGET) $(OBJS) $(LDFLAGS)

clean:
	rm -rf *.o $(TARGET) .\#* \#* *~ core

=== examples/example6/Makefile ===

TARGET  := ../bin/example6

CC      := g++
CFLAGS  := -g -Wall -I../../include
LDFLAGS := -L ../.. -lFCam -ljpeg -lpthread -lpulse-simple
FILES   := example6 SoundPlayer

OBJS = $(addsuffix .o, $(FILES))

.cpp.o:
	$(CC) $(CFLAGS) -c $< -o $@

build: $(OBJS)
	$(CC) -o $(TARGET) $(OBJS) $(LDFLAGS)

clean:
	rm -rf *.o $(TARGET) .\#* \#* *~ core

=== debian/changelog ===
fcam (1.1.1-1) unstable; urgency=low

  * 1296x968 RAW now works (648x492 still doesn't).

  * dcraw and derived libraries can now find our thumbnails

  * The settings of the last shot are left as the V4L2 device state on exit now, to allow other V4L2 devices to piggyback on our settings.

 -- Andrew Adams <abadams@stanford.edu>  Wed, 23 Sep 2010 18:43:00 -0700

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Package: fcam-dev
 Section: libdevel
 Architecture: any
-Depends: libjpeg62-dev 
+Depends: 
 Description: FCam Camera Control API
 XSBC-Bugtracker: https://garage.maemo.org/tracker/?group_id=1693
  Development package for the FCam camera control API.
